function love.load()
bg=love.graphics.newImage("0.jpg")
rwall=love.graphics.newImage("1.png")
lwall=love.graphics.newImage("2.png")
bdrop=love.graphics.newImage("3.png")
ldrop=love.graphics.newImage("4.png")
bucket=love.graphics.newImage("5.png")
font=love.graphics.newImageFont("6.png", "0123456789")
love.graphics.setFont(font)
score=0
--starting bucket position
bx=200
--call drop.add to start its timer
drop.add()
end
--entity tables
drop={}
droplet={}
popup={}
st=0

function love.draw()
love.graphics.draw(bg, 0, 0)
love.graphics.draw(rwall, 360, 0)
love.graphics.draw(lwall, 0, 0)
love.graphics.printf(score, 284, 16, 100, 'right')
love.graphics.draw(bucket, bx, 340)
drop.draw()
droplet.draw()
popup.draw()
end

function love.update(dt)
if 40 > love.mouse.getX() then bx=40
elseif 307 < love.mouse.getX() then bx=307
else bx=love.mouse.getX() end
drop.update(dt)
if timer <= love.timer.getTime() then drop.add() end
droplet.update(dt)
popup.update(dt)
if st <= love.timer.getTime() then s=0 end
end

--the functions for the falling drops
function drop.draw()
for i,v in ipairs(drop) do
love.graphics.draw(bdrop,v.x,v.y)
end end
function drop.update(dt)
for i,v in ipairs(drop) do
v.y=v.y+v.yv*dt
v.yv=v.yv+3
v.x=v.x+v.xv*dt
if v.x<=40 then v.xv=v.xv*-1 end
if v.x>=344 then v.xv=v.xv*-1 end
if v.y>=400 then table.remove(drop,i) end
if v.y>=324 and v.y<=332 and v.x>=bx and v.x<=bx+53 then drop.catch(i,v.x,v.y) end
end end
function drop.add()
x=math.random(47000,337000)/1000
xv=math.random(-120000,120000)/1000
table.insert(drop,{w=16,h=16,x=x,y=-24,xv=xv,yv=8})
timer=love.timer.getTime()
timer=math.random(500,5000)/10000+timer
end
function drop.catch(i,x,y)
table.remove(drop,i)
s=s+5
st=love.timer.getTime()+0.6
score=score+s
x=x+2
y=y+4
droplet.add(x,y) droplet.add(x,y) droplet.add(x,y)
popup.add(x,y,s)
end

--the finctions for smaller drops created by catching a big drop
function droplet.add(x,y)
yv=math.random(100000,200000)/-1000
xv=math.random(-120000,120000)/1000
table.insert(droplet,{w=12,h=12,x=x,y=y,xv=xv,yv=yv})
end
function droplet.draw()
for i,v in ipairs(droplet) do
love.graphics.draw(ldrop,v.x,v.y)
end end
function droplet.update(dt)
for i,v in ipairs(droplet) do
v.y=v.y+v.yv*dt
v.yv=v.yv+8
v.x=v.x+v.xv*dt
if v.x<=40 then v.xv=v.xv*-1 end
if v.x>=344 then v.xv=v.xv*-1 end
if v.y>=400 then table.remove(droplet,i) end
if v.y>=328 and v.y<=334 and v.x>=bx and v.x<=bx+53 and v.yv>0 then droplet.catch(i,v.x,v.y) end
end end
function droplet.catch(i,x,y)
table.remove(droplet,i)
s=s+2
st=love.timer.getTime()+0.6
score=score+s
popup.add(x,y,s)
end

--the functions that create little numbers to diplay your score increase with each catch
function popup.add(x,y,s)
table.insert(popup,{x=x,y=y,a=255,s=s})
end
function popup.draw()
for i,v in ipairs(popup) do
love.graphics.setColor(255,255,255,v.a)	--set alpha
love.graphics.printf(v.s, v.x, v.y, 4)
love.graphics.setColor(255,255,255)	--restore alpha
end end
function popup.update(dt)
for i,v in ipairs(popup) do
v.a=v.a-300*dt
if v.a<1 then table.remove(popup,i) end
v.y=v.y-80*dt
end end